const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const revenue_summaries = sequelize.define(
    'revenue_summaries',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      month: {
        type: DataTypes.TEXT,
      },

      total_amount: {
        type: DataTypes.DECIMAL,
      },

      payer_breakdown: {
        type: DataTypes.TEXT,
      },

      growth_pct: {
        type: DataTypes.DECIMAL,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  revenue_summaries.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.revenue_summaries.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.revenue_summaries.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.revenue_summaries.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.revenue_summaries.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return revenue_summaries;
};
